#ifndef INCLUDED_VECTOR_H
#define INCLUDED_VECTOR_H

typedef struct
{
    INT32   x, y;
} POINT2D;

typedef struct
{
    INT32   x, y;
} VECTOR2D;

typedef struct
{
    float   x, y, z;
} VECTOR3D;

typedef struct
{
    float       dist;           // distance from world origin to plane
    VECTOR3D    unit_normal;    // unit normal from world origin pointing at
                                // plane
} PLANE;

extern void     Vec3D_NormalizeYZ(VECTOR3D *);
extern void     Vec3D_Rotate(VECTOR3D *, float, float, float);
extern float    Vec3D_RawDotProduct(VECTOR3D *, VECTOR3D *);

#endif  // INCLUDED_VECTOR_H
